﻿package {
	import flash.display.*;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import fl.motion.MatrixTransformer;
	import flash.geom.*;
	import flash.filters.*;


	public class Starmaker extends Sprite {
		private var i:Number=0;
		private var w:Number=0;
		private var k:Number=0;
		private var d:Number=0;
		var blue:Shape=new Shape();
		var blueMC:MovieClip=new MovieClip  ;
		var curBlueAng:Number=0;
		var blueMat:Matrix=blue.transform.matrix.clone();
		var count:Number= 0 ;
		



		private var blueRotCenter:Point=new Point(450,220);


		public function Starmaker() {
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
			blueMC.addChild(blue);
			addChild(blueMC);
			var blueMat:Matrix=blue.transform.matrix.clone();
			drawShapes();
			this.addEventListener(Event.ENTER_FRAME,onEnter);

		}
		private function drawShapes():void {

			blue.graphics.lineStyle();

			blue.graphics.beginFill(0x000066);

			//blue.graphics.drawRect(-60,-60,120,120);

			blue.graphics.endFill();

			//------------------

			blue.graphics.beginFill(0xCC0000);

			blue.graphics.drawCircle(blueRotCenter.x,blueRotCenter.y,3);

			blue.graphics.endFill();

		}
		function onEnter(e:Event):void {

			curBlueAng=(curBlueAng-2)%360;
			rotateBlue(10);

		}
		function rotateBlue(deg:Number):void {

			var mat:Matrix=blueMat.clone();
			MatrixTransformer.rotateAroundInternalPoint(mat,blueRotCenter.x,blueRotCenter.y,deg);
			blue.transform.matrix=mat;

		}

		private function addedHandler(e:Event):void {
			addEventListener(Event.ENTER_FRAME, enterHandler);
			stage.addEventListener(MouseEvent.CLICK,click_handler);
		}

		private function click_handler(e:MouseEvent):void {
			blue.graphics.clear();
			i=0;
			count = 0;
		}

		private function enterHandler(e:Event):void {
			count++;
			trace(count);
			var blur =	new BlurFilter(count*0.02, count*0.02, 1);
			blue.filters = [blur];
			
			if (i<350) {
				if (! i) {
					var d:Number=1+Math.random()*3;
					this.x=stage.stageWidth/2;
					this.y=stage.stageHeight/2;
					graphics.moveTo(0,0);
					graphics.beginFill(0x000000,1);
					w=0;
				}
				k=0;
				while (k++<200) {
					
					blue.graphics.beginFill(0x000000,1);
					blue.graphics.drawCircle(X/3,Y/3,Math.random()*8);


					//blue.graphics.lineStyle(1,0x000000,1);
					var X:Number=Math.sin(i+=d)*i;
					var Y:Number=Math.cos(i)*i;
					//blue.graphics.lineTo(X,Y);
				}
			} else {
				this.rotation+=w;
				w+=0.1;
			}

		}
	}
}